// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if(spaceAvailable < spaceRequired)
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return(false);
  }

  return(true);
}

var srDest = 1;
var version = "0.7";
var err = initInstall("conquery", "conquery", version); 
logComment("initInstall: " + err);

// profile installs only work since 2003-03-06
const INST_TO_PROFILE = "ConQuery installation location:\n [Ok] -> user profile\n[Cancel] -> application directory.";
var instToProfile = confirm(INST_TO_PROFILE);
var chromef = instToProfile ? getFolder("Profile", "chrome") : getFolder("chrome");
var jar = getFolder(chromef, "conquery.jar");

if (verifyDiskSpace(getFolder("Program"), srDest))
{
SearchPluginsFolder = getFolder('Program', 'searchplugins/');
addFile("ConQuery", "ConQuery/AlexaSiteInfo.cqr", SearchPluginsFolder,""); 
addFile("ConQuery", "ConQuery/altavistababelfish.cqr", SearchPluginsFolder,""); 
addFile("ConQuery", "ConQuery/apnicwhois.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/arinwhois.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/lacnic.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/GoogleAdvanced.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/merriam-webster.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/ripewhois.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/w3c-validatethis.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/lxr_linux.cqr", SearchPluginsFolder,"");
addFile("ConQuery", "ConQuery/psc.cqr", SearchPluginsFolder,"");

    addFile("conquery",
            "conquery.jar", // jar source folder 
            chromef,        // target folder
            "");                        // target subdir 

    if (instToProfile) {
        registerChrome(CONTENT | PROFILE_CHROME, jar, "content/conquery/");
    }
    else {
        registerChrome(CONTENT | DELAYED_CHROME, jar, "content/conquery/");
    }

    if (err == SUCCESS) {
        performInstall(); 
    }
    else {
        cancelInstall(err);
    }
}
else
    cancelInstall(INSUFFICIENT_DISK_SPACE);
